=== debian/control ===
Source: ros-humble-tracetools-acceleration
Section: misc
Priority: optional
Maintainer: Víctor Mayoral-Vilches <victorma@xilinx.com>
Build-Depends: debhelper (>= 9.0.0), pkg-config, ros-humble-ament-cmake-ros, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-tracetools-acceleration
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-ros-workspace
Description: LTTng tracing provider wrapper for ROS 2 packages using hardware acceleration.
 Fork of tracetools to trace hardware acceleration in ROS 2.
